#include "../stdafx.h"
#include <string.h>
#include "MultiDllGen.h"
#include "../MainWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CMultiDllGen::~CMultiDllGen()
{
	if (listDllGen.GetSize() != 0)
	{
		CString dllGenKey = "";
		dllGenKey.Format(_T("dllGenName%d"), listDllGen.GetSize());
		AfxGetApp()->WriteProfileString(_T("Preferences"), dllGenKey, _T("NONE"));
		do
		{
			currentDllGen = (CDllGen *)listDllGen[listDllGen.GetSize() - 1];
			dllGenKey.Format(_T("dllGenName%d"), listDllGen.GetSize() - 1);
			AfxGetApp()->WriteProfileString(_T("Preferences"), dllGenKey, currentDllGen->GetFilePath());
			delete currentDllGen;
			currentDllGen = NULL;
			listDllGen.SetSize(listDllGen.GetSize() - 1);
		}
		while (listDllGen.GetSize() != 0);
	}
}

CMultiDllGen::CMultiDllGen(HWND hWnd)
{
#ifndef _UNICODE
	CString dllGenName = "";
	CString dllGenKey = "";
	int i = 0;
	do
	{
		listDllGen.SetSize(listDllGen.GetSize() + 1);
		TRACE(_T("listDllGen.GetSize() %d"), listDllGen.GetSize());
		dllGenKey.Format(_T("dllGenName%d"), i);
		dllGenName = AfxGetApp()->GetProfileString(_T("Preferences"), dllGenKey, _T(""));
		if (dllGenName == "NONE")
			dllGenName = "";
		if (dllGenName != "" && dllGenName != "STANDARD")
		{
			currentDllGen = new CDllGen(dllGenName, hWnd);
			if (dllGenName != currentDllGen->GetFilePath() && dllGenName != "STANDARD" && dllGenName != "")
			{
				delete currentDllGen;
				listDllGen.SetSize(listDllGen.GetSize() - 1);
				currentDllGen = NULL;
			}
			else
				listDllGen[listDllGen.GetSize() - 1] = (CObject *)currentDllGen;
		}
		else
			listDllGen.SetSize(listDllGen.GetSize() - 1);
		i++;
	}
	while (dllGenName.GetLength() != 0);
#endif
}

void CMultiDllGen::SethwndParent(HWND hWnd)   // winamp's main window (filled in by winamp)
{
	for (int i = 0; i < listDllGen.GetSize(); i++)
	{
		CDllGen* curDllGen = (CDllGen*)listDllGen[i];
		curDllGen->SethwndParent(hWnd);
	}
}

int CMultiDllGen::Init()
{
	for (int i = 0; i < listDllGen.GetSize(); i++)
	{
		CDllGen* curDllGen = (CDllGen*)listDllGen[i];
		curDllGen->Init();
	}
	return 0;
}
void CMultiDllGen::Quit()
{
	for (int i = 0; i < listDllGen.GetSize(); i++)
	{
		CDllGen* curDllGen = (CDllGen*)listDllGen[i];
		curDllGen->Quit();
	}
}

void CMultiDllGen::Config(int pos)
{
	CDllGen* curDllGen = (CDllGen*)listDllGen[pos];
	curDllGen->Config();
}

int CMultiDllGen::GetSize() // return the number of loaded gen
{
	return listDllGen.GetSize();
}

CDllGen* CMultiDllGen::getDllGen(int pos) //Return the DllGen at pos
{
	return (CDllGen *)listDllGen[pos];
}

void CMultiDllGen::UnLoad(int pos) //Unload the DllGen at pos
{
#ifndef _UNICODE
	if (pos < listDllGen.GetSize())
	{
		CDllGen* gen = (CDllGen*)listDllGen[pos];
		gen->Quit();
		delete gen;
		for (int i = pos; i < listDllGen.GetSize() - 1; i++)
			listDllGen[i] = listDllGen[i + 1];
		listDllGen.SetSize(listDllGen.GetSize() - 1);
		if (listDllGen.GetSize() != 0)
			currentDllGen = (CDllGen *)listDllGen[0];
		else
			currentDllGen = NULL;
	}
#endif
}

void CMultiDllGen::Load(CString file, HWND hWnd) //Load the DllGen
{
#ifndef _UNICODE
	CDllGen* gen = new CDllGen(file, hWnd);
	if (gen->GetFilePath() != "STANDARD")
	{
		listDllGen.SetSize(listDllGen.GetSize() + 1);
		listDllGen[listDllGen.GetSize() - 1] = gen;
		gen->Init();
	}
	else
		delete gen;
#endif
}

void CMultiDllGen::UpDllGen(int pos) //Up the DllGen in the list
{
#ifndef _UNICODE
	if (pos == 0)
		return;
	CDllGen* gen = (CDllGen*)listDllGen[pos];
	listDllGen[pos] = listDllGen[pos - 1];
	listDllGen[pos - 1] = gen;
#endif
}
