// StreamingDialog.cpp
//

#include "../stdafx.h"

#include "CommonFunc.h"

#include "../wa_ipc.h"
#include "TagInfo.h"
#include "in_mpg123.h"

#include "HttpFile.h"
#include "ICYInfo.h"

#include "Param.h"
#include "StreamingDialog.h"
#include "PropertySheet.h"
#include "../MainHelper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void reflect_setting(void);
void reflect_thread_setting(void);

BOOL CALLBACK in_streaming_dialog_proc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_THRAD_PRIORITY);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_BUFFER_SIZE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_HTTP_PROXY);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_SAVE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_TITLE_STREAMING);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_TITLE_FORMAT);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_EXAMPLE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_CH_ENABLE_STREAMING);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_PROXY);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_SAVESTREAM);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_TITLESTREAMING);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_TITLESTREAMING_UDP);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_TITLESTREAMING_DECODE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_KB);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_BUTTON_FILEDIALOG);

			SendDlgItemMessage(hDlg, IDC_CH_ENABLE_STREAMING, BM_SETCHECK, prm->m_bEnableStreaming ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_PROXY, BM_SETCHECK, prm->m_bProxy ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_SAVESTREAM, BM_SETCHECK, prm->m_bSaveStream ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_TITLESTREAMING, BM_SETCHECK, prm->m_bTitleStreaming ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_TITLESTREAMING_UDP, BM_SETCHECK, prm->m_bTitleStreamingUDP ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_TITLESTREAMING_DECODE, BM_SETCHECK, prm->m_bTitleStreamingDecode ? BST_CHECKED : BST_UNCHECKED, 0);
			SetDlgItemText(hDlg, IDC_ED_SAVESTREAM, prm->m_strSaveStream);
			SetDlgItemText(hDlg, IDC_ED_PROXY, prm->m_strProxy);

			CString tmp;
			tmp.Format("%d", prm->m_nBufferLength);
			SetDlgItemText(hDlg, IDC_ED_STRBUF, tmp);
			SetDlgItemText(hDlg, IDC_ED_TITLESTREAMING_FORMAT, prm->m_strTitleStreamingFormat);

			CString buf = m_HelperIn.MyLoadString(IDS_LNORMAL);
			SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_LABOVENORMAL);
			SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_LHIGHEST);
			SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)buf);

			SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_SETCURSEL, prm->m_nReceiveThreadPriority, 0);

			SendMessage(hDlg, WM_COMMAND, IDC_TITLESTREAMING, 0);
			SendMessage(hDlg, WM_COMMAND, IDC_SAVESTREAM, 0);
			SendMessage(hDlg, WM_COMMAND, IDC_PROXY, 0);
			break;
		}
	case WM_NOTIFY:
		{
			LPPSHNOTIFY lppsn = (LPPSHNOTIFY)lParam;
			switch (lppsn->hdr.code)
			{
			case PSN_APPLY :
				{
					prm->m_bEnableStreaming = SendDlgItemMessage(hDlg, IDC_CH_ENABLE_STREAMING, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_bProxy = SendDlgItemMessage(hDlg, IDC_PROXY, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_bSaveStream = SendDlgItemMessage(hDlg, IDC_SAVESTREAM, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_bTitleStreaming = SendDlgItemMessage(hDlg, IDC_TITLESTREAMING, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_bTitleStreamingUDP = SendDlgItemMessage(hDlg, IDC_TITLESTREAMING_UDP, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_bTitleStreamingDecode = SendDlgItemMessage(hDlg, IDC_TITLESTREAMING_DECODE, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					CWnd::FromHandle(hDlg)->GetDlgItemText(IDC_ED_PROXY, prm->m_strProxy);
					CWnd::FromHandle(hDlg)->GetDlgItemText(IDC_ED_SAVESTREAM, prm->m_strSaveStream);
					CString tmp;
					CWnd::FromHandle(hDlg)->GetDlgItemText(IDC_ED_STRBUF, tmp);
					prm->m_nBufferLength = Max(atoi(tmp), MIN_STREAM_SIZE / 1024);
					CWnd::FromHandle(hDlg)->GetDlgItemText(IDC_ED_TITLESTREAMING_FORMAT, prm->m_strTitleStreamingFormat);

					bool bFlag = false;

					if (prm->m_nReceiveThreadPriority != SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_GETCURSEL, 0, 0))
					{
						prm->m_nReceiveThreadPriority = SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_GETCURSEL, 0, 0);
						bFlag = true;
					}
					if (bFlag)
					{
						::reflect_thread_setting();
					}
					::reflect_setting();
					break;
				}
			case PSN_QUERYCANCEL:
				EndDialog(hDlg, LOWORD(wParam));
				break;
			}
			break;
		}
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_PROXY:
			if (SendDlgItemMessage(hDlg, IDC_PROXY, BM_GETCHECK, 0, 0) == BST_CHECKED)
			{
				EnableWindow(GetDlgItem(hDlg, IDC_ED_PROXY), TRUE);
			}
			else
			{
				EnableWindow(GetDlgItem(hDlg, IDC_ED_PROXY), FALSE);
			}
			return FALSE;
		case IDC_SAVESTREAM:
			if (SendDlgItemMessage(hDlg, IDC_SAVESTREAM, BM_GETCHECK, 0, 0) == BST_CHECKED)
			{
				EnableWindow(GetDlgItem(hDlg, IDC_ED_SAVESTREAM), TRUE);
				EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_FILEDIALOG), TRUE);
			}
			else
			{
				EnableWindow(GetDlgItem(hDlg, IDC_ED_SAVESTREAM), FALSE);
				EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_FILEDIALOG), FALSE);
			}
			return FALSE;
		case IDC_TITLESTREAMING:
			if (SendDlgItemMessage(hDlg, IDC_TITLESTREAMING, BM_GETCHECK, 0, 0) == BST_CHECKED)
			{
				EnableWindow(GetDlgItem(hDlg, IDC_TITLESTREAMING_DECODE), TRUE);
				EnableWindow(GetDlgItem(hDlg, IDC_TITLESTREAMING_UDP), TRUE);
			}
			else
			{
				EnableWindow(GetDlgItem(hDlg, IDC_TITLESTREAMING_DECODE), FALSE);
				EnableWindow(GetDlgItem(hDlg, IDC_TITLESTREAMING_UDP), FALSE);
			}
			return FALSE;
		case IDC_BUTTON_FILEDIALOG:
			{
				CString str;

				str.LoadString(IDS_SAVESTREAMDLG);

				CFileDialog FileDialog(FALSE, "*.mp3", "notitle.mp3", OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST, str,
									   CWnd::FromHandle(hDlg), 0);
				if (FileDialog.DoModal() == IDOK)
				{
					SetDlgItemText(hDlg, IDC_ED_SAVESTREAM, FileDialog.GetPathName());
				}
				return FALSE;
			}
		case BN_CLICKED:
			break;
		case IDOK:
		case IDCANCEL:
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}

	return TRUE;
}

